/*
*  FreerTOS versjon av basic CanSat
*  Denne programskissen fungerer kun på Mega2560.
*  Leser GPS, temperatur,  høyde og trykk og sender til RF
*  csv-fil til SD og RF
*  RF: baudrate 57600;
*  GPS:baudrate 38400;
*  Serial (Console) baudrate 115200
* (C) Skule Sørmo 8.april 2015
*
**
*************************/

#define RF_port Serial1
#define GPS_port Serial2

#include <FreeRTOS_AVR.h>

#include <SPI.h>
//#include <SD.h>
#include <SdFat.h>
#include <Wire.h>
#include <Adafruit_BMP085.h>

Adafruit_BMP085 bmp;
 
 struct AMessage
 {
    int MessageID;
    String buf;
    float flytvar;
    uint16_t Int16;
    uint32_t  Int32;   
 };
AMessage Message1,Message2,Message3; 

char buf[12] = "logg001.csv";
const int chipSelect = 4;
String GPS_buffer = "", st = "";;
String filename = "";
File Datafile;
char c;
portBASE_TYPE s1, s2, s3, s4;
xQueueHandle Queue, SDQueue;

//String buf1[100] = "";
//String buf2 = "";
SdFat SD;

void setup() {
  RF_port.begin(57600);
  GPS_port.begin(38400);
  Serial.begin(115200);
  Message1.buf.reserve(100);
  Message2.buf.reserve(100);
  Message3.buf.reserve(100);
  GPS_buffer.reserve(100);
  RF_port.println(__FILE__);
  RF_port.print("Kompilert den ");
  RF_port.println("08.04.2015");
  RF_port.println("(C) Skule Sormo");
  Serial.println(__FILE__);
  Serial.print("Kompilert den ");
  Serial.println("08.04.2015");
  Serial.println("(C) Skule Sormo");

  if (!bmp.begin()) {
    Serial.println("Could not find a valid BMP085 sensor, check wiring!");
    while (1) {}
  }

  Serial.print("Initializing SD card...");
  // On the Ethernet Shield, CS is pin 4. It's set as an output by default.
  // Note that even if it's not used as the CS pin, the hardware SS pin
  // (10 on most Arduino boards, 53 on the Mega) must be left as an output
  // or the SD library functions will not work.
  pinMode(10, OUTPUT);

  if (!SD.begin(4)) {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");

  // open the file. note that only one file can be open at a time,
  // so you have to close this one before opening another.

  int n = 1;

  while ((SD.exists(buf)))   // finner neste filnavn:
  {
    st = String(n++);
    if (st.length() == 1) st = "00" + st;
    else if (st.length() == 2) st = "0" + st;
    st = "logg" + st + ".csv";
    st.toCharArray(buf, 12) ;
    // Serial.println(buf);
  }
  filename = st;
  Serial.print("Filnavn: ");
  Serial.println(filename);
/*  //	Serial.print("SD: ");
  //	Serial.println(buf);
  buf2 = "test";
  Datafile = SD.open(buf, FILE_WRITE);
  if (Datafile)
  {
    Datafile.println(__TIMESTAMP__);
    Datafile.println(buf2);
    Datafile.close();
  }
  else Serial.println("Feilet SD");
*/
  if (!bmp.begin())   // initierer temp/trykk
	Serial.println("Could not find a valid BMP085 sensor, check wiring!");

  Queue = xQueueCreate( 10, sizeof( AMessage) );

  s1 = xTaskCreate(Thread1, NULL, configMINIMAL_STACK_SIZE + 300, NULL, 2, NULL); // GPS
  s2 = xTaskCreate(Thread2, NULL, configMINIMAL_STACK_SIZE+400, NULL,2, NULL);  // RF send buffer
  s3 = xTaskCreate(Thread3, NULL, configMINIMAL_STACK_SIZE+400, NULL,2, NULL);  // Buffer receive
  
  Serial.println("Data sendes til RF (Serial1) og lagres pa SD");
  vTaskStartScheduler();
}

void loop(){}   // nothing to do
  
  static void Thread1(void*rg) // GPS
{
   Serial.println("GPS startet...");
  while (1)
  {
     while (GPS_port.available())
    {
      c = GPS_port.read();
      if (int(c) == 13)
      {   // bruker bare $GPRMC-tag:
         if ((GPS_buffer[0]=='$')&&(GPS_buffer[1]=='G')&&(GPS_buffer[2]=='P')&&(GPS_buffer[3]=='R')&&(GPS_buffer[4]=='M')&&(GPS_buffer[5]=='C'))
        {
         Message2.buf=GPS_buffer;
         Message2.MessageID=1;
         xQueueSendToBack(Queue, &Message2, 50);
        }
        GPS_buffer = "";
      }
      else if  (int(c) != 10)
        GPS_buffer += c;
    }
   vTaskDelay(10);
  }
}


static void Thread2(void*rg) // IMU
{
      Serial.println("Variabellesning startet..");

   
  while (1)
{
      Message1.MessageID=2;
      Message1.flytvar=bmp.readTemperature();
      xQueueSendToBack(Queue, &Message1, 50);

      Message1.MessageID=3;
      Message1.Int32=bmp.readPressure();
      xQueueSendToBack(Queue, &Message1, 50);

    // Calculate altitude assuming 'standard' barometric
    // pressure of 1013.25 millibar = 101325 Pascal
      Message1.MessageID=4;
      Message1.flytvar=bmp.readAltitude(101500);
      xQueueSendToBack(Queue, &Message1, 50);

      Message1.MessageID=5;
      Message1.Int32=bmp.readSealevelPressure();
      xQueueSendToBack(Queue, &Message1, 50);

    // you can get a more precise measurement of altitude
    // if you know the current sea level pressure which will
    // vary with weather and such. If it is 1015 millibars
    // that is equal to 101500 Pascals.
      Message1.MessageID=6;
      Message1.flytvar=bmp.readAltitude(101500);
      xQueueSendToBack(Queue, &Message1, 50);
      vTaskDelay(200);
  }
}


static void Thread3(void*rg) // Queue
{
      Serial.println("Kolesning og transfer startet...");
  while (1)
  {
        if ( xQueueReceive( Queue, &Message3, 50) )
    {
   Datafile = SD.open(buf, FILE_WRITE);
   Datafile.println(__TIMESTAMP__);
      switch (Message3.MessageID) {
      case 1:  RF_port.print("GPS, ");RF_port.println(Message3.buf); 
               Datafile.print("GPS, ");Datafile.println(Message3.buf);   break;
      case 2:  RF_port.print("Temperature, ");RF_port.println(Message3.flytvar,2);
               Datafile.print("Temperature, ");Datafile.println(Message3.flytvar,2);   break;
      case 3:  RF_port.print("Pressure, ");RF_port.println(Message3.Int32);
               Datafile.print("Pressure, ");Datafile.println(Message3.Int32);   break;
      case 4:  RF_port.print("Altitude, ");RF_port.println(Message3.flytvar,2);
               Datafile.print("Altitude, ");Datafile.println(Message3.flytvar,2);   break;
      case 5:  RF_port.print("Pressure sealevel, ");RF_port.println(Message3.Int32);
              Datafile.print("Pressure sealevel, ");Datafile.println(Message3.Int32);  break; 
      case 6:  RF_port.print("Real altitude, ");RF_port.println(Message3.flytvar,2);
               Datafile.print("Real altitude, ");Datafile.println(Message3.flytvar,2);  break; 
      };
       Datafile.close();
      }
    vTaskDelay(10);
  }
}


